<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_ContactNumber ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_ContactNumber extends AbstractStructArrayBase
{
    /**
     * The PhoneNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_ContactNumber[]
     */
    public $PhoneNumber;
    /**
     * Constructor method for ArrayOfJPSOAP_ContactNumber
     * @uses ArrayOfJPSOAP_ContactNumber::setPhoneNumber()
     * @param \StructType\JPSOAP_ContactNumber[] $phoneNumber
     */
    public function __construct(array $phoneNumber = array())
    {
        $this
            ->setPhoneNumber($phoneNumber);
    }
    /**
     * Get PhoneNumber value
     * @return \StructType\JPSOAP_ContactNumber[]|null
     */
    public function getPhoneNumber()
    {
        return $this->PhoneNumber;
    }
    /**
     * This method is responsible for validating the values passed to the setPhoneNumber method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPhoneNumber method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePhoneNumberForArrayConstraintsFromSetPhoneNumber(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJPSOAP_ContactNumberPhoneNumberItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_ContactNumberPhoneNumberItem instanceof \StructType\JPSOAP_ContactNumber) {
                $invalidValues[] = is_object($arrayOfJPSOAP_ContactNumberPhoneNumberItem) ? get_class($arrayOfJPSOAP_ContactNumberPhoneNumberItem) : sprintf('%s(%s)', gettype($arrayOfJPSOAP_ContactNumberPhoneNumberItem), var_export($arrayOfJPSOAP_ContactNumberPhoneNumberItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PhoneNumber property can only contain items of type \StructType\JPSOAP_ContactNumber, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PhoneNumber value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_ContactNumber[] $phoneNumber
     * @return \ArrayType\ArrayOfJPSOAP_ContactNumber
     */
    public function setPhoneNumber(array $phoneNumber = array())
    {
        // validation for constraint: array
        if ('' !== ($phoneNumberArrayErrorMessage = self::validatePhoneNumberForArrayConstraintsFromSetPhoneNumber($phoneNumber))) {
            throw new \InvalidArgumentException($phoneNumberArrayErrorMessage, __LINE__);
        }
        $this->PhoneNumber = $phoneNumber;
        return $this;
    }
    /**
     * Add item to PhoneNumber value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_ContactNumber $item
     * @return \ArrayType\ArrayOfJPSOAP_ContactNumber
     */
    public function addToPhoneNumber(\StructType\JPSOAP_ContactNumber $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_ContactNumber) {
            throw new \InvalidArgumentException(sprintf('The PhoneNumber property can only contain items of type \StructType\JPSOAP_ContactNumber, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PhoneNumber[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_ContactNumber|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_ContactNumber|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_ContactNumber|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_ContactNumber|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_ContactNumber|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PhoneNumber
     */
    public function getAttributeName()
    {
        return 'PhoneNumber';
    }
}
